<template>
  <div>
    <v-container>
      <div class="row justify-content-center">
        <div class="col-md-3 col-sm-3 col-xs-12"></div>
        <div class="col-md-9 col-sm-9 col-xs-12">
          <v-breadcrumbs class="pb-0" :items="breadcrums"></v-breadcrumbs>

          <v-divider></v-divider>

          <div class="row text-center">
            <div
              class="col-md-3 col-sm-6 col-xs-12"
              :key="index"
              v-for="(item, index) in apidata"
            >
              <v-hover v-slot:default="{ hover }">
                <v-card
                  align="center"
                  class="mx-auto"
                  color="grey lighten-4"
                  max-width="600"
                >
                  <v-img
                    class="white--text align-end"
                    :aspect-ratio="16 / 9"
                    height="200px"
                    :src="item.dynamicImageUrl"
                  >
                    <v-card-title>{{ item.model }} </v-card-title>

                    <v-expand-transition>
                      <div
                        v-if="hover"
                        class="d-flex transition-fast-in-fast-out white darken-2 v-card--reveal display-3 white--text"
                        style="height: 100%"
                      >
                        <v-btn
                          v-if="hover"
                          class=""
                          @click="newOrder(item)"
                          outlined
                          >BUY</v-btn
                        >
                      </div>
                    </v-expand-transition>
                  </v-img>

                  <v-card-text class="text--primary">
                    <div>
                      <a href="/product" style="text-decoration: none">{{
                        item.detail.model
                      }}</a>
                    </div>
                    <div>${{ item.price }}</div>
                    <div>Memory:{{ item.detail.memory }}</div>
                    <div>Color:{{ item.detail.color }}</div>
                    <div>Amout:{{ item.amount }}</div>
                  </v-card-text>
                </v-card>
              </v-hover>
            </div>
          </div>
          <v-dialog v-model="dialogedit" max-width="500px">
            <v-card>
              <v-card-title class="headline">{{ savemode }}</v-card-title>
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12">
                      <v-text-field
                        v-model="productItem"
                        label="items"
                        id="items"
                        readonly
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-col cols="12">
                      <v-text-field
                        v-model="productPrice"
                        label="total_price"
                        type="number"
                        id="total_price"
                        readonly
                      ></v-text-field> </v-col
                  ></v-row>
                  <v-row>
                    <v-col cols="12">
                      <v-text-field
                        v-model="postOrder.amount"
                        label="amount"
                        @input="totalprice()"
                        type="number"
                        id="amount"
                      ></v-text-field>
                    </v-col>
                  </v-row>

                  <v-row>
                    <v-col cols="12">
                      <v-text-field
                        v-model="allPrice"
                        label="allPrice"
                        type="number"
                        id="amount"
                        readonly
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-btn color="blue darken-1" text @click="dialogedit = false"
                  >Cancel</v-btn
                >
                <v-btn color="blue darken-1" text @click="saveSelect()"
                  >Confirm</v-btn
                >
              </v-card-actions>
              <div>
                <p>{{ productItem }}</p>
              </div>
            </v-card>
          </v-dialog>
        </div>
      </div>
    </v-container>
  </div>
</template>
<style>
.v-card--reveal {
  align-items: center;
  bottom: 0;
  justify-content: center;
  opacity: 0.8;
  position: absolute;
  width: 100%;
}
</style>
<script>
export default {
  data() {
    return {
      allPrice: "",
      productItem: "",
      dialogedit: false,
      productPrice: "",
      dynamicImageUrl: "",
      postdefault: {
        brand: "",
        price: "",
        amount: "",
        detail: "",
      },
      postdata: {
        brand: "",
        price: "",
        amount: "",
        detail: "",
      },

      postOrderdefault: {
        items: "",
        amount: "",
        total_price: "",
      },
      postOrder: {
        items: "",
        amount: "",
        total_price: "",
      },

      apidata: [],
    };
  },
  created() {
    this.getDataProduct();
    this.getDataOrder();
  },
  computed: {
    savemode() {
      return this.id == "" ? "" : "Create Order";
    },
  },

  methods: {
    async totalprice() {
      this.allPrice = this.productPrice * this.postOrder.amount;
      console.log("this.allPrice: ", this.allPrice);
    },
    async newOrder(item) {
      this.productPrice = item.price; //ราคาสินค้า
      this.productItem = item.detail.model; //ชื่อสินค้า
      this.idProduct = item._id;
      this.amoutOrder = item.amount;
      this.id = "";
      this.postOrder = { ...this.postOrderdefault };
      this.postOrder.items = this.productItem; //เอาชื่อสินค้าที่เลือกมาใส่ในออปเจ็กของออเด้อ
      // this.postOrder.total_price = this.allPrice;
      this.dialogedit = true;
      console.log("all price in oreder: ", this.postOrder.total_price);
    },

    saveSelect() {
      if (this.id != "") {
        this.savePutData();
        console.log("put:", this.productItem);
      } else {
        this.savePostOrderData();
        console.log("post:", this.allPrice);
      }
    },

    getDataOrder() {
      this.axios
        .get("http://localhost:3000/listOrder/")
        .then((response) => {
          this.apiOrderdata = response.data.data;

          // this.getDynamicImage();
        })
        .catch((error) => {
          console.error("Error fetching order data:", error);
        });
    },
    getDataProduct() {
      this.axios.get("http://localhost:3000/product/").then((response) => {
        this.apidata = response.data.data;
        this.getDynamicImage();
        console.log("Dataaa: ", this.apidata);
      });
    },
    closeItem() {
      this.id = "";
      this.postdata = { ...this.postdefault };
      this.dialogedit = false;
    },
    getDynamicImage() {
      for (let i = 0; i < this.apidata.length; i++) {
        const findImg = this.apidata[i];
        // ตรวจสอบว่า findImg.detail ไม่เป็น undefined ก่อนที่จะเข้าถึงค่า model
        if (findImg.detail && findImg.detail.model) {
          if (
            findImg.detail.model === "I Phone 15" &&
            findImg.detail.color === "Black"
          ) {
            this.apidata[i].dynamicImageUrl =
              "https://media.education.studio7thailand.com/78973/iPhone_15_Pro_Max_Black_Titanium_1.jpg";
            // return this.apidata[i].dynamicImageUrl;
          } else if (
            findImg.detail.model === "I Phone 15 ProMax" &&
            findImg.detail.color === "White Titanium"
          ) {
            this.apidata[i].dynamicImageUrl =
              "https://store.storeimages.cdn-apple.com/8756/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-1inch-whitetitanium?wid=1200&hei=630&fmt=jpeg&qlt=95&.v=1692846367180";
          } else if (
            findImg.detail.model === "I phone 15 ProMax" &&
            findImg.detail.color === "Black Titanium"
          ) {
            this.apidata[i].dynamicImageUrl =
              "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-7inch-blacktitanium?wid=5120&hei=2880&fmt=p-jpg&qlt=80&.v=VW44dkRidm5wazhwcGxtL0cyaEJ2VTkrNXBUdUJSK1k4NE5seUtJaW80ZEVRNFN1aThHM1R3Z1g3RUVXYlJtU2lCQmV2WTA2cncybDF2YzFnKzI0S3J4M3lYcDIyK01lckZBaW5GTC9DMEQxcjBVRyswWG14bEI4WVZBcUIybEYyQ1lHTzV4YUgyTWtSdk02UmRER0p3PT0=&traceId=1";
          } else if (
            findImg.detail.model === "I phone 15 ProMax" &&
            findImg.detail.color === "blue"
          ) {
            this.apidata[i].dynamicImageUrl =
              "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-7inch-bluetitanium?wid=5120&hei=2880&fmt=p-jpg&qlt=80&.v=VW44dkRidm5wazhwcGxtL0cyaEJ2VTkrNXBUdUJSK1k4NE5seUtJaW80Y0hGc1VYcU5MZG1Wc3p5djdGRkpkOXB3azBNWWRMTTJUR1Y1SkFQMTJmYytRU0p3cnVrZzhmdWQwTDVYRlMxUFpLVUtTU1p5Q3hjSjJnWUpQQWJXd2o0TDRqc1ZQcWdXTk1hOTBSVG5aenpBPT0=&traceId=1";
          } else if (
            findImg.detail.model === "I Phone 15" &&
            findImg.detail.color === "Green"
          ) {
            this.apidata[i].dynamicImageUrl =
              "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-finish-select-202309-6-1inch-green_FMT_WHH?wid=1280&hei=492&fmt=p-jpg&qlt=80&.v=cHJOTXEwTU92OEtKVDV2cVB1R2FTSjlERndlRTljaUdZeHJGM3dlLzR2OEIzenlaemVZcXF4dWN4a1o1bms5UGJWU3RPOURZS0RCaG1weXBRYytNTEZIMVU3blhIMm9GdXVFaFpISW1jUE4vd3djUElYUEl5ak9OVThyMUdieDBBdzM2VnRnZmw5M0I2VVpZMzZLdklnPT0=&traceId=1";
          }
        }
      }
      return "";
    },

    async savePostOrderData() {
      try {
        console.log("this.allPrice savePostOrderData : ", this.allPrice);
        this.postOrder.total_price = this.allPrice;
        const { data } = await this.axios.post(
          "http://localhost:3000/listOrder/",
          this.postOrder
        );
        console.log("data: ", data);
        console.log(" this.postdata: ", this.productItem);
        alert("Create Order Complete");

        this.callculateOrder();
        this.getDataOrder();
        this.closeItem();
      } catch (error) {
        console.log(error);
        alert(error);
      }
    },
    async callculateOrder() {
      const order = this.postOrder.amount; // order ที่รับมา
      const productsID = this.idProduct; //id product ที่ เลื่อก
      const products = this.apidata; // product ทั้งหมด

      console.log("order: ", order);
      console.log("ID product: ", productsID); //
      console.log("product: ", products);
      try {
        for (let i = 0; i < products.length; i++) {
          if (products[i]._id == productsID) {
            console.log(products[i]._id == productsID);
            const updatedAmount = products[i].amount - order;

            await this.axios.put(
              "http://localhost:3000/product/" + products[i]._id,
              { amount: updatedAmount } // ส่งข้อมูลที่ต้องการอัปเดตในรูปแบบของออบเจ็กต์
            );
          }
        }
        this.getDataProduct();
      } catch (error) {
        console.error("An error occurred:", error);
      }
    },
  },
};
</script>
